-- --------------------------------------------------------------------
-- 技能tips
-- 
-- @author: cloud@syg.com(必填, 创建模块的人员)
-- @editor: xxx@syg.com(必填, 后续维护以及修改的人员)
-- @description:
--      这里填写详细说明,主要填写该模块的功能简要
-- <br/>Create: 2018-xx-xx
-- --------------------------------------------------------------------

SkillTips = SkillTips or BaseClass(BaseView) 

local string_format = string.format

function SkillTips:__init( ... )
    self.is_full_screen = false
    self.title_str= ""
    self.layout_name = "tips/gw_skill_tips"
    self.res_list = {
        --{ path = PathTool.getPlistImgForDownLoad("tips","tips"), type = ResourcesType.plist },
        --{ path = PathTool.getPlistImgForDownLoad("gw_common/tips_window","tips_window_bg", false), type = ResourcesType.single },
        --{ path = PathTool.getPlistImgForDownLoad("gw_common/tips_window","tips_window_line", false), type = ResourcesType.single },
    }
    self.win_type = WinType.Tips   
    self.view_tag = ViewMgrTag.DIALOGUE_TAG 
end

--[[
@功能:构建UI
@参数:
@返回值:
]]
function SkillTips:open_callback( ... )
    self.background = self.root_wnd:getChildByName("background")
    if self.background ~= nil then
        self.background:setScale(display.getMaxScale())
    end
    self.main_panel = self.root_wnd:getChildByName("main_panel")

    self.container = self.main_panel:getChildByName("container")
    self.container_init_size = self.container:getChildByName("Image_214"):getContentSize()

    self.base_panel = self.container:getChildByName("base_panel")
    self.base_panel_height = self.base_panel:getContentSize().height

    self.scroll_view = self.container:getChildByName("scroll_view")
    self.scroll_view:setScrollBarEnabled(false)
    self.scroll_container = self.scroll_view:getChildByName("scroll_container")

    self.skill_icon = self.base_panel:getChildByName("skill_node")
    --self.skill_icon:setScale(0.8)
    self.skill_icon.icon = self.skill_icon:getChildByName("icon")
    self.skill_icon.lev_bg = self.skill_icon:getChildByName("lev_bg")
    self.skill_icon.lev_label = self.skill_icon:getChildByName("lev_label")
    self.skill_icon.icon_cover = self.skill_icon:getChildByName("icon_cover")
    --self.skill_icon:setVisible(false)
    --self.skill_item = SkillItem.new(false,false,false,nil,nil,false)
    --self.skill_item:setPosition(76, 68)
    --self.base_panel:addChild(self.skill_item)
    --self.skill_lv = self.base_panel:getChildByName("skill_lv")
    self.skill_name = self.base_panel:getChildByName("name")
    self.skill_type = self.base_panel:getChildByName("skill_type")
    local skill_type_label = self.base_panel:getChildByName("skill_type_label")
    skill_type_label:setString(UI_TI18N(3001))
    self.skill_type:setPositionX(skill_type_label:getPositionX() + skill_type_label:getContentSize().width)

    self.line = self.container:getChildByName("line")
end

function SkillTips:register_event()
    if self.background then 
        self.background:addTouchEventListener(function(sender, event_type) 
            if event_type == ccui.TouchEventType.ended then
                playCloseSound()
                self:close()
            end
        end)
    end
end

--[[
@功能:设置技能信息
@参数:Config.Skill   ,  Config.RoleCareerSkill
@返回值:
]]
function SkillTips:updateVo( skill_vo, is_lock, not_show_next, hide_flag, fire_cd, hallows_atk_val )
    self.skill_vo = skill_vo
    local level = skill_vo.level or 1
    if skill_vo.client_lev and skill_vo.client_lev>0 then
        level = skill_vo.client_lev
    end

    --技能等级
    self.skill_icon.lev_label:setString(string.format("Lv.%d", level))

	-- 技能名字
    if not hide_flag then
        --self.skill_name:setString(string.format("%s  Lv.%d", skill_vo.name, level))
        StringUtil.gw_setLabelContent(self.skill_name, string.format("%s  Lv.%d", skill_vo.name, level), 270)
    else
        --self.skill_name:setString(string.format("%s", skill_vo.name))
        StringUtil.gw_setLabelContent(self.skill_name, string.format("%s", skill_vo.name), 270)
    end
	-- self.skill_name:setString(skill_vo.name)
    -- loadSpriteTexture(self.skill_icon, PathTool.getSkillRes(skill_vo.icon), LOADTEXT_TYPE) 
    --self.skill_item:setData(skill_vo)
    local id = skill_vo.skill_bid or  skill_vo.skill_id or skill_vo.bid
    local skill_config = Config.SkillData.data_get_skill(id)
    local skill_icon = PathTool.getSkillRes(skill_config.icon, false)
    PathTool.gw_setSkillIconForImage(self.skill_icon.icon, self.skill_icon_icon_load, skill_icon)
    --self.skill_icon.icon:loadTexture(skill_icon, LOADTEXT_TYPE)
    --self.skill_icon:setVisible(true)
    --loadSpriteTexture(self.skill_icon.icon, skill_icon, LOADTEXT_TYPE)

    self.skill_type:setVisible(true)
    if skill_vo.type == "active_skill" then 
        self.skill_type:setString(UI_TI18N(3002))
    else 
        self.skill_type:setString(UI_TI18N(3003))
    end

    -- 统计最大高度
    local total_height = 0--self.base_panel_height + 7

    local skill_des_height = 0
    if self.skill_vo.des ~= "" then
        if self.skill_desc == nil then
            self.skill_desc = createRichLabel(22,cc.c4b(0x5b,0x5d,0x5e,0xff),cc.p(0,1),cc.p(28,10),8,nil,346)
            self.scroll_container:addChild(self.skill_desc)
        end
        if self.skill_vo.hallows_atk and self.skill_vo.hallows_atk > 0 and hallows_atk_val then
            local skill_atk_val = self.skill_vo.hallows_atk
            local total_atk_val = skill_atk_val + hallows_atk_val
            local str = string.format(self.skill_vo.des, total_atk_val, hallows_atk_val)
            self.skill_desc:setString(str)
        else
            self.skill_desc:setString(self.skill_vo.des)
        end
        skill_des_height = self.skill_desc:getContentSize().height 
        total_height  = total_height + skill_des_height + 21
    end

    local extend_desc_height = 0
    if self.extend_desc == nil then
        self.extend_desc = createRichLabel(22,cc.c4b(0x3a,0x3d,0x40,0xff),cc.p(0,1),cc.p(28,10),nil,nil,346)
        self.scroll_container:addChild(self.extend_desc)
    end
    if not hide_flag then
        local extend_str = ""
        if self.skill_vo.cd == 0 then
            extend_str = UI_TI18N(3004)
        else
            extend_str = string_format(UI_TI18N(3005),self.skill_vo.cd)
        end
        if fire_cd and fire_cd ~= 0 then
            fire_cd = fire_cd
        else
            fire_cd = self.skill_vo.fire_cd or 0
        end
        if fire_cd ~= 0 then
            if self.skill_vo.cd == 0 then
                extend_str = string_format(UI_TI18N(3006), fire_cd)
            else
                extend_str = string_format(UI_TI18N(3007),self.skill_vo.cd, fire_cd)
            end
        end
        self.extend_desc:setString(extend_str)
    end

    extend_desc_height = self.extend_desc:getContentSize().height
    total_height  = total_height + extend_desc_height + 32

    local buff_desc_str = ""
    local buff_desc_height = 0
    local buff_len = 0
    self.buff_desc_list = {}
    if self.skill_vo.buff_des ~= nil and self.skill_vo.buff_des[1] and next(self.skill_vo.buff_des[1]) then
        total_height  = total_height + 15
        local buff_config = Config.SkillData.data_get_buff
        local index = 1
        for i, v in ipairs(self.skill_vo.buff_des[1]) do
            local config = buff_config[v]
            if config then
                if self.buff_desc_list[index] == nil then
                    self.buff_desc_list[index] = {}
                    self.buff_desc_list[index].name = createRichLabel(24,cc.c4b(0x15,0x84,0x78,0xff),cc.p(0,1),cc.p(28,10),nil,nil,346)
                    self.scroll_container:addChild(self.buff_desc_list[index].name)
                    self.buff_desc_list[index].desc = createRichLabel(22,cc.c4b(0x52,0x52,0x52,0xff),cc.p(0,1),cc.p(28,10),8,nil,370)
                    self.scroll_container:addChild(self.buff_desc_list[index].desc)
                end

                self.buff_desc_list[index].name:setString(string_format(UI_TI18N(3008), config.name))
                total_height  = total_height + 32
                self.buff_desc_list[index].desc:setString(string_format("%s", config.desc))
                total_height  = total_height + self.buff_desc_list[index].desc:getContentSize().height + 15

                buff_len = buff_len + 1
                index = index + 1
            else
                Debug.error("找不到技能buff配置！！！id:"..v)
            end
        end
    end

    -- 下级描述
    if self.skill_vo.open_desc ~= "" and not not_show_next and not hide_flag then
        self.line:setVisible(true)
        local next_skill_des = ""
        if is_lock then -- 未开启
            next_skill_des = self.skill_vo.open_desc
        elseif self.skill_vo.next_id == 0 then -- 已满级
            next_skill_des = string_format(UI_TI18N(3009))
        else
            next_skill_des = self.skill_vo.skill_desc
        end
        if self.next_skill_txt == nil then
            self.next_skill_txt = createRichLabel(20,cc.c4b(0x52,0x52,0x52,0xff),cc.p(0.5,0.5),cc.p(200,35),4,nil,346)
            self.container:addChild(self.next_skill_txt)
        end
        self.next_skill_txt:setString(next_skill_des)
        --total_height  = total_height + 60
    else
        self.line:setVisible(false)
    end

    --self.container:setContentSize(cc.size(self.container_init_size.width, total_height))
    --self.container:setPositionY(360 + total_height*0.5)
    self.scroll_container:setContentSize(cc.size(self.container_init_size.width, total_height))
    --self.scroll_view:setScrollHeight()
    if total_height > self.scroll_view:getContentSize().height then
        self.scroll_view:setTouchEnabled(true)
        self.scroll_container:setPositionY(total_height)
        self.scroll_view:setInnerContainerSize(cc.size(self.container_init_size.width, total_height))
    else
        self.scroll_view:setTouchEnabled(false)
    end
    local pos_y = total_height
    --self.base_panel:setPositionY(pos_y)
    pos_y = pos_y - 5
    if self.skill_desc ~= nil then
        self.skill_desc:setPositionY(pos_y)
    end
    pos_y = pos_y - skill_des_height - 21
    if self.extend_desc ~= nil then
        self.extend_desc:setPositionY(pos_y)
    end
    pos_y = pos_y - extend_desc_height - 20

    for i=1,buff_len do
        self.buff_desc_list[i].name:setPositionY(pos_y)
        pos_y = pos_y - 32
        self.buff_desc_list[i].desc:setPositionY(pos_y)
        pos_y = pos_y - self.buff_desc_list[i].desc:getContentSize().height - 15
    end

    --self.line:setPositionY(64)
    if self.next_skill_txt then
        self.next_skill_txt:setPositionY(34)
    end
end

--function SkillTips:updatePosition()
--    self.root_wnd:setContentSize(cc.size(504,self.max_height))
--    self.back:setContentSize(cc.size(504,self.max_height))
--    self.skill_type:setPositionY(self.max_height-110)
--    self.skill_back:setPositionY(self.max_height-145)
--    self.skill_name:setPositionY(self.max_height-50)
--    self.skill_lev:setPositionY(self.max_height-80)
--    self.desc3:setPositionY(self.max_height-170)
--    self.desc1:setPositionY(self.max_height-170)
--    self.line1:setPositionY(self.max_height-155)
--end

function SkillTips:setPosition(x, y)
    -- self.root_wnd:setAnchorPoint(cc.p(0, 1))
    -- self.root_wnd:setPosition(cc.p(x, y))
end


function SkillTips:setPos(x, y)
    -- self.root_wnd:setPosition(cc.p(x, y))
end

function SkillTips:getContentSize()
    return self.root_wnd:getContentSize()
end

--[[
@功能:打开技能tips
@参数:
@返回值:
]]
function SkillTips:openRootWnd( config, is_lock, not_show_next, hide_flag, fire_cd, hallows_atk_val )
    self:updateVo(config, is_lock, not_show_next, hide_flag, fire_cd, hallows_atk_val)

	-- ViewManager:getInstance():addToLayerByTag(self.root_root,ViewMgrTag.MSG_TAG)
    delayRun(self.root_wnd, 114, function()
        TipsManager:getInstance():hideTips()
    end)
end

function SkillTips:close_callback( ... )
    if self.skill_icon_icon_load then
        self.skill_icon_icon_load:DeleteMe()
        self.skill_icon_icon_load = nil
    end
    -- if self.root_root then
    --     self.root_root:removeAllChildren()
    --     self.root_root:removeFromParent()
    -- end
end
